<!DOCTYPE html>
<html lang="en">

<head>
	<title>67.S10</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<!-- Font Awesome -->
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Voucher</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="voucher-code">Mã Voucher</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Phần trăm giảm giá</label>
				</div>
				<div class="col-sm-9">
					<input type="number" id="input-discount" name="discount" placeholder="Discount"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Ghi chú</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="createDate">Ngày Tạo</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-createDate" name="createDate" placeholder="Create Date"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="updateDate">Ngày sửa</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date"
						class="form-control" disabled>
				</div>
			</div>
			<div class="row pull-right">
				<div class="col-sm-12">
					<button id="save_data" class="btn btn-info">Save Data</button>
				</div>
				<br><br>
				<div class="col-sm-12">
					<button id="delete_all_data" class="btn btn-danger">Delete All Data</button>
				</div>
			</div>
		</div>
		<table class="table table-bordered table-striped table-hover" id="user-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>Mã giảm giá</th>
					<th>Phần trăm giảm giá</th>
					<th>Ghi Chú</th>
					<th>Ngày tạo</th>
					<th>Ngày cập nhật</th>
					<th>Action</th>
				</tr>
		</table>
	</div>
	<!-- Update Order modal -->
	<div>
		<div id="update-voucher-modal" class="modal fade" tabindex="-1">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="h5-modal-title">Update Trạng Thái Voucher</h5>
						<button class="close" data-dismiss="modal">&times;</button>
					</div>
					<div class="modal-body">
						<form>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Mã Voucher</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-mavoucher" class="form-control">
								</div>
							</div>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Phần trăm giảm giá</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-phantram" class="form-control">
								</div>
							</div>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Ghi Chú</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-ghichu" class="form-control">
								</div>
							</div>
						</form>
					</div>
					<div class="modal-footer">
						<button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
						<button class="btn btn-primary" id="btn-update-voucher">Update Trạng Thái</button>
					</div>
				</div>
			</div>
		</div>
	</div>

	<!-- Delete confirm modal -->
	<div>
		<div class="modal fade" tabindex="-1" id="delete-confirm-modal">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="h5-modal-title">Voucher Delete Confirmation</h5>
						<button class="close" data-dismiss="modal">&times;</button>
					</div>
					<div class="modal-body">
						<label>Bạn có chắc chắn muốn xóa Voucher này không?</label>
					</div>
					<div class="modal-footer">
						<button class="btn btn-danger" id="btn-confirm-delete-voucher">Confirm</button>
						<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
					</div>
				</div>
			</div>
		</div>
	</div>
	<!-- Delete All confirm modal -->
	<div>
		<div class="modal fade" tabindex="-1" id="delete-all-confirm-modal">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="h5-modal-title">Voucher Delete Confirmation</h5>
						<button class="close" data-dismiss="modal">&times;</button>
					</div>
					<div class="modal-body">
						<label>Bạn có chắc chắn muốn xóa tất cả Voucher này không?</label>
					</div>
					<div class="modal-footer">
						<button class="btn btn-danger" id="btn-all-confirm-delete-voucher">Confirm</button>
						<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
					</div>
				</div>
			</div>
		</div>
	</div>
	<script>
		$(document).ready(function () {
			var gVoucher_code = {
				id: "",
			}
			onPageLoading();
			$("#save_data").on("click", function () {
				onButtonCreateClick(); // this là button được ấn
			});
			$("#delete_all_data").on("click", function () {
				onButtonModalAllDeleteClick(); // this là button được ấn
			});
			// khi ấn sự kiện edit
			$("#user-table").on("click", ".edit-voucher", function () {
				onButtonChiTietClick(this); // this là button được ấn
			});
			// khi ấn nút sự kiện update trên modal
			$("#btn-update-voucher").on("click", function () {
				onBtnUpdateClick();
			});
			// khi ấn sự kiện delete
			$("#user-table").on("click", ".delete-voucher", function () {
				onBtnDeleteConfirmOrderClick(this);
			});
			// gán sự kiện cho nút Delete  (trên modal)
			$("#btn-confirm-delete-voucher").on("click", function () {
				onBtnDeleteVoucherClick();
			});
			$("#btn-all-confirm-delete-voucher").on("click", function () {
				onButtonDeleteAllClick(); // this là button được ấn
			});
			var table = $("#user-table").DataTable({
				"columns": [
					{ "data": "id" },
					{ "data": "maVoucher" },
					{ "data": "phanTramGiamGia" },
					{ "data": "ghiChu" },
					{ "data": "ngayTao" },
					{ "data": "ngayCapNhat" },
					{ "data": "action" }
				],
				columnDefs: [
					{
						targets: 6,
						defaultContent: '<i class="fas fa-pen text-info edit-voucher"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-voucher"></i>'
					}]
			})
			function onPageLoading() {
				$.ajax({
					url: "http://localhost:8080/vouchers",
					type: "GET",
					dataType: "json",
					success: function (res) {
						console.log(res);
						table.clear();
						table.rows.add(res);
						table.draw();
					},
					error: function (err) {
						console.log(err.response);
					}
				})
			}
			// Hàm sự kiện thêm voucher
			function onButtonCreateClick() {
				// khai báo dữ liệu
				var vVoucherObj = {
					maVoucher: "",
					phanTramGiamGia: "",
					ghiChu: "",
					ngayTao: ""
				}
				// thu thập thông tin 
				getCreateData(vVoucherObj);
				// validate
				if (kiemtraCreateData(vVoucherObj)) {
					// Tạo mới order
					createVoucher(vVoucherObj);
				}
			}
			// hàm thu thập thông tin để create order
			function getCreateData(paramObj) {
				paramObj.maVoucher = $("#input-voucher-code").val();
				paramObj.phanTramGiamGia = $("#input-discount").val();
				paramObj.ghiChu = $("#input-note").val();
				paramObj.ngayTao = $("#input-createDate").val();
				paramObj.ngayCapNhat = $("#input-updateDate").val();
			}
			function kiemtraCreateData(paramObj) {
				if (paramObj.maVoucher == "" || isNaN(paramObj.maVoucher) == true) {
					alert("Bạn điền mã Voucher không hợp lệ")
					return false;
				}
				if (paramObj.phanTramGiamGia == "" || isNaN(paramObj.phanTramGiamGia) == true) {
					alert("Bạn điền phần trăm giảm giá không hợp lệ")
					return false;
				}
				if (paramObj.ngayTao == "") {
					alert("Bạn chưa nhập ngày tạo!");
					return false;
				}
				return true;
			}
			//Hàm tạo đơn mói
			function createVoucher(paramObj) {
				$.ajax({
					url: "http://localhost:8080/vouchers",
					type: 'POST',
					data: JSON.stringify(paramObj),
					contentType: "application/json; charset=utf-8",
					dataType: 'json',
					success: function (paramObjVoucher) {
						//hiển thị dữ liệu lên web
						console.log(paramObjVoucher);
						onPageLoading();
						alert("Bạn tạo thành công voucher");
					},
					error: function (error) {
						alert("Bạn tạo Đơn Voucher thất bại!");
						console.log(error.responseText)
					}
				});
			}
			function onButtonModalAllDeleteClick(){
				$("#delete-all-confirm-modal").modal("show");
			}
			// infoFunction sẽ là function các nút cùng gọi
			function onButtonChiTietClick(paramChiTietButton) {
				//Xác định thẻ tr là cha của nút được chọn
				var vRowSelected = $(paramChiTietButton).parents('tr');
				//Lấy datatable row
				var vDatatableRow = table.row(vRowSelected);
				//Lấy data của dòng 
				var vOrderData = vDatatableRow.data();
				gVoucher_code.id = vOrderData.id;
				// lấy api để load vào modal
				getVoucherbyVoucherID();
				$("#update-voucher-modal").modal("show");
			}
			function onBtnDeleteConfirmOrderClick(paramChiTietButton) {
				//Xác định thẻ tr là cha của nút được chọn
				var vRowSelected = $(paramChiTietButton).parents('tr');
				//Lấy datatable row
				var vDatatableRow = table.row(vRowSelected);
				//Lấy data của dòng 
				var vOrderData = vDatatableRow.data();
				gVoucher_code.id = vOrderData.id;
				// lấy api để load vào modal
				$("#delete-confirm-modal").modal("show");
			}
			function getVoucherbyVoucherID() {
				$.ajax({
					url: "http://localhost:8080/vouchers/" + gVoucher_code.id,
					type: "GET",
					dataType: 'json',
					success: function (responseObject) {
						//debugger;
						loadDataToModal(responseObject);
					},
					error: function (error) {
						console.assert(error.responseText);
					}
				});
			}
			// hàm load data to modal update
			function loadDataToModal(paramResponseObject) {
				$("#input-update-mavoucher").val(paramResponseObject.maVoucher);
				$("#input-update-phantram").val(paramResponseObject.phanTramGiamGia);
				$("#input-update-ghichu").val(paramResponseObject.ghiChu);
			}
			// khi bấm nút Update trên modal
			function onBtnUpdateClick() {
				console.log(gVoucher_code.id);
				//khai báo dữ liệu
				var vObjectRequest = {
					maVoucher: "",
					phanTramGiamGia: "",
					ghiChu: "",
				}
				// gán dữ liệu
				vObjectRequest.maVoucher = $("#input-update-mavoucher").val();
				vObjectRequest.phanTramGiamGia = $("#input-update-phantram").val();
				vObjectRequest.ghiChu = $("#input-update-ghichu").val();
				//validate
				var validate = IstrangThai(vObjectRequest);
				if (validate) {
					//cập nhật trạng thái
					updateVoucher(vObjectRequest);
				}
			}
			function IstrangThai(paramObj) {
				if (paramObj.maVoucher == "" || isNaN(paramObj.maVoucher) == true) {
					alert("Bạn điền mã Voucher không hợp lệ")
					return false;
				}
				if (paramObj.phanTramGiamGia == "" || isNaN(paramObj.phanTramGiamGia) == true) {
					alert("Bạn điền phần trăm giảm giá không hợp lệ")
					return false;
				}
				return true;
			}
			//update Voucher
			function updateVoucher(paramObj) {
				$.ajax({
					url: "http://localhost:8080/vouchers/" + gVoucher_code.id,
					type: "PUT",
					data: JSON.stringify(paramObj),
					contentType: "application/json; charset=utf-8",
					dataType: 'json',
					success: function (responseObject) {
						//debugger;
						handleUpdatetSuccess(responseObject.id);
					},
					error: function (error) {
						console.assert(error.responseText);
					}
				});
			}
			// hàm xử lý sự kiện delete order modal click
			function onBtnDeleteVoucherClick() {
				//khai báo dữ liệu
				//validate
				//gọi api
				$.ajax({
					url: "http://localhost:8080/vouchers/" + gVoucher_code.id,
					type: "DELETE",
					contentType: "application/json; charset=utf-8",
					success: function (paramRes) {
						// B4: xử lý front-end
						handleDeleteVoucherSuccess();
					},
					error: function (paramErr) {
						console.log(paramErr.status);
					}
				});
				//hiển thị thông tin
			}
			// hàm xử lý hiển thị front-end khi update Trạng thái thành công
			function handleUpdatetSuccess(paramObj) {
				onPageLoading();
				alert("Update Voucher Id = " + paramObj + " thành công!");
				$("#update-voucher-modal").modal("hide");
			}
			// hàm xử lý hiển thị front-end khi sửa voucher thành công
			function handleDeleteVoucherSuccess() {
				onPageLoading();
				alert("Xóa Voucher thành công!");
				$("#delete-confirm-modal").modal("hide");
			}
			//Sự kiện xóa hết dữ liệu
			function onButtonDeleteAllClick() {
				//khai báo dữ liệu
				//validate
				//gọi api
				$.ajax({
					url: "http://localhost:8080/vouchers",
					type: "DELETE",
					contentType: "application/json; charset=utf-8",
					success: function (paramRes) {
						onPageLoading();
						// B4: xử lý front-end
						alert("Xóa Tất cả danh sách Voucher thành công!");
						$("#delete-all-confirm-modal").modal("hide");
					},
					error: function (paramErr) {
						console.log(paramErr.status);
					}
				});
			}

		});

	</script>
</body>

</html>